<template>
  <div class="calendar-sidebar">
    <div id="external-events">
      <v-btn class="ml-6 mt-6" color="success" @click="onCreateFatherTask">
        <div>צור משימה</div>
        <v-icon>mdi-plus</v-icon>
      </v-btn>
      <div id="external-events-listing">
        <div v-for="domain in domains" :key="domain.id" class="mt-6">
          <v-checkbox
            v-model="domainsFilter"
            :label="domain.name"
            :value="domain.id"
          ></v-checkbox>
          <div
            v-for="task in GetUnscheduleTasks.filter(
              (task) => task.domain_id === domain.id
            )"
            :key="task.id"
            :id="task.id"
            @click="
              $emit('external-event-click', { event: { extendedProps: task } })
            "
            class="fc-event"
          >
            {{ task.title }}
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// import { format } from "date-fns";
import { Draggable } from "@fullcalendar/interaction";
import { mapGetters, mapActions, mapMutations } from "vuex";

export default {
  // name: "CalendarSidebar",
  computed: {
    ...mapGetters("metadata", ["domains", "taskTypes"]),
    ...mapGetters(["GetUnscheduleTasks", "filters"]),
    domainsFilter: {
      get() {
        return this.filters.domains;
      },
      set(value) {
        this.setFilters({ domains: value });
      },
    },
  },
  methods: {
    ...mapActions["fetchAllTasks"],
    ...mapMutations(["setFilters"]),
    onCreateFatherTask: function() {
      this.$root.$emit("call-father-task-dialog");
    },
  },
  mounted: function() {
    let draggableElements = document.getElementById("external-events-listing");
    new Draggable(draggableElements, {
      itemSelector: ".fc-event",
      eventData: function(eventEl) {
        return {
          title: eventEl.innerHTML,
          id: eventEl.id,
        };
      },
    });
  },
};
</script>

<style scoped>
/* body {
  margin-top: 40px;
  text-align: center;
  font-size: 14px;
  font-family: "Lucida Grande", Helvetica, Arial, Verdana, sans-serif;
}

#wrap {
  width: 1100px;
  margin: 0 auto;
} */

#external-events {
  float: left;
  width: 200px;
  padding: 0 10px;
  border: 1px solid #ccc;
  background: #eee;
  text-align: left;
}

#external-events h4 {
  padding-left: 20px;
  font-size: 16px;
  margin-top: 0;
  padding-top: 1em;
  align-self: right;
}

.fc-event {
  /* position: relative; */
  text-align: right;
  color: white;
  display: block;
  font-size: 0.85em;
  line-height: 1.3;
  border-radius: 5px;
  border: 1px solid #3788d8;
  background-color: #3788d8;
  font-weight: 400;
}

#external-events .fc-event {
  margin: 10px 0;
  cursor: pointer;
}

.checkbox label {
  text-align: right;
  float: left;
}
</style>
